from setuptools import setup

with open("README.md", "r", encoding="utf-8") as readme:
	long_description = readme.read()

setup(
	name = "mahab",
	version = "1.0.0",
	description = "Mahab battery protector software (Persian) for GNU/Linux distributions",
	long_description = long_description,
	long_description_content_type = "text/markdown",
	author = "Abolfazl Ramazani",
	author_email = "abolfazlramazani86@gmail.com",
	url='https://abramazani.github.io/mahab',
	license = "MIT",
	packages = ['mahab'],
	package_dir = {"mahab": "mahab/"},
	classifiers = [
		"Programming Language :: Python :: 3",
		"License :: OSI Approved :: MIT License",
		"Operating System :: POSIX :: Linux",
		"Natural Language :: Persian"],
	entry_points = {
		"console_scripts": ["mahab=mahab.mahab:main"]},
	data_files = [
		("share/applications/", ["mahab.desktop"])],
	keywords = "battery protector",
	python_requires = ">=3.6",
	install_requires=['arabic-reshaper==2.1.3', 'AwesomeTkinter==2021.11.8', 'future==0.18.2', 'Pillow==8.3.2', 'playsound==1.3.0', 'psutil==5.8.0', 'pyglet==1.5.21', 'python-bidi==0.4.2', 'pytz==2021.1', 'six==1.16.0']
)

